<template>
    <div class="list-view">
        <div class="filters-container">
            <div>
                <span class="span-width">
                    <span class="span-size">考官姓名</span>
                    <el-input placeholder="考官姓名" v-model="search" clearable class="filter-item"></el-input>
                </span>
                <span class="span-width">
                    <span class="span-size">证件号码</span>
                    <el-input placeholder="证件号码" v-model="search" clearable class="filter-item"></el-input>
                </span>
                <span class="span-width">
                    <span class="span-size">考级机构名称</span>
                    <el-input placeholder="考级机构名称" v-model="search" clearable class="filter-item"></el-input>
                </span>
            </div>
            <div>
                <span class="span-width">
                    <span class="span-size">是否外聘</span>
                    <el-select class="filter-item" style="width: 200px">
                        <el-option value="true" label="是"></el-option>
                        <el-option value="false" label="否"></el-option>
                    </el-select>
                </span>
                <span class="span-width">
                    <span class="span-size">专业名称</span>
                    <el-input placeholder="专业名称" v-model="search" clearable class="filter-item"></el-input>
                </span>
                <span class="span-width">
                    <span class="span-size">职称</span>
                    <el-input placeholder="职称" v-model="search" clearable class="filter-item"></el-input>
                </span>
            </div>
            <label class="span-size">考级机构所在区域</label>
            <el-select class="filter-item" v-model="province" style="width: 200px">
                <el-option value="江苏省" label="江苏省"></el-option>
            </el-select>
            <el-select class="filter-item" v-model="city">
                <el-option value="南京市" label="南京市"></el-option>
            </el-select>
            <el-select class="filter-item" v-model="districtId" clearable placeholder="请选择区县">
                <el-option v-for="item in district" :key="item.id" :value="item.name" :label="item.name"></el-option>
            </el-select>
            <div style="margin-left: 129px">
                <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button>
                <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button>
            </div>
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            height="tableHeight"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <!-- <el-table-column prop="username" label="用户名" min-width="300"> </el-table-column> -->
            <el-table-column prop="nickname" label="考官姓名"> </el-table-column>
            <el-table-column label="证件号码" min-width="100"><span>3201001184401011111</span></el-table-column>
            <!-- <el-table-column prop="phone" label="手机号"></el-table-column> -->
            <el-table-column prop="work" label="所属考级机构" min-width="100"></el-table-column>
            <el-table-column label="考级机构所在区域"><span>江苏省南京市</span></el-table-column>
            <el-table-column label="是否外聘" width="80"><span>否</span></el-table-column>
            <el-table-column prop="artType" label="专业名称"></el-table-column>
            <el-table-column prop="position" label="职称"></el-table-column>
            <!-- <el-table-column label="头像" min-width="300">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px;"
                        :src="row.avatar"
                        fit="cover"
                        :preview-src-list="[row.avatar]"
                    ></el-image>
                </template>
            </el-table-column> -->
            <el-table-column label="操作" align="center" fixed="right">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>编辑</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import ClipboardJS from 'clipboard';
const clickData = {};
export default {
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/user/all1',
            downloading: false,
            province: '江苏省',
            city: '南京市'
        };
    },
    computed: {
        ...mapState([]),
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            if (this.search) {
                return { search: this.search };
            }
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/expertEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/expertEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/user/excel', { responseType: 'blob' })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        clickId(row) {
            if (row.id !== clickData.id) {
                clickData.id = row.id;
                clickData.c = 0;
            }
            clickData.c = (clickData.c || 0) + 1;
            if (clickData.i) {
                clearInterval(clickData.i);
            }
            clickData.i = setTimeout(_ => {
                clickData.c = 0;
            }, 200);
            if (clickData.c === 5) {
                this.$http
                    .get(`/user/getToken/${row.id}`)
                    .then(res => {
                        let el = document.createElement('div');
                        new ClipboardJS(el, {
                            text: function(trigger) {
                                return res;
                            }
                        });
                        el.click();
                        this.$message.success('已复制Token');
                        clickData.c = 0;
                    })
                    .catch(e => {
                        this.$message.error(e.error);
                    });
            }
        }
    }
};
</script>
<style lang="less" scoped>
.span-size {
    font-size: 14px;
    color: #565b66;
    line-height: 15px;
    padding: 0 10px 0 10px;
}
.span-width {
    width: 342px;
    display: inline-block;
    text-align: right;
}
.span-width2 {
    width: 500px;
    // float: left;
    text-align: right;
    display: inline-block;
}
</style>
